# ----(Description)------------------------------------------------------------
# Original code by Darryl Perry, 2003, A Cyberia BBS Production
#
# This is a replacement for Mystic BBS's 'NS' or "Send Message to a node"
# command.  This command is used when you wish to send a message to all active
# nodes, but do not wish to send it to the node that issues the command.
#
# This code is given freely to the public domain, but please give credit 
# where credit is due.  Do not change this code and call it your own.
#------------------------------------------------------------------------------
Uses Cfg
Uses Dir
Uses User

Var Active	Boolean
Var Action	String
Var Name	String
Var Loc		String
Var Gender	Char
Var Age		Byte
Var Baud	String
Var Invis	Boolean
Var Avail	Boolean
Var InChat	Boolean
Var Room	Byte

Var Node	String	
Var Ttxt	String	

Function ReadChat(Path String): Integer
Var I1	Integer
Begin
	I1:=0
	If fExist(Path) Then
		fOpen(1,Bin,Reset,Path)
		fReadRec(1,Active)
		fReadRec(1,Name,30)
		fReadRec(1,Action,40)
		fReadRec(1,Loc,30)
		fReadRec(1,Gender)
		fReadRec(1,Age)
		fReadRec(1,Baud,6)
		fReadRec(1,Invis)
		fReadRec(1,Avail)
		fReadRec(1,InChat)
		fReadRec(1,Room)
		fClose(1)
		I1:=1
	Else
		I1:=0
	Endif
	ReadChat:=I1
Pend

Procedure RunNodes 
Var Path	String
Var Len		Integer
Var I2		Integer
Begin
	Path:=CfgDataPath+'chat*.dat'
	FindFirst(Path,AnyFile)
	While DosError = 0
		Len:=Length(DirName)
		If Len > 9 Then
			If Len > 10 Then
				Node:=Copy(DirName,5,3)
			Else
				Node:=Copy(DirName,5,2)
			Endif
		Else
			Node:=Copy(DirName,5,1)
		Endif
		If DirName <> 'chatroom.dat' Then
			If ReadChat(CfgDataPath+DirName) = 1 Then
				If Active and Str2Int(Node) <> NodeNum Then
					MenuCmd('NS',Node + ';' + TTxT)
				Endif
			Endif
		Endif
		FindNext
	Wend
	FindClose
Pend

Procedure MakeTxt
Var	P1	Integer
Var I1	Integer
Begin
	GetThisUser
	TTxt:=ParamStr(1)
	For I1:=2 to ParamCount
		TTxT:=TTxT+' '+ParamStr(I1)	
	Fend
	Repeat
		P1:=Pos('|&1',TTxT)
		If P1>0 Then
			If PathChar = '/'	   # Delete function is different between
				Delete(TTxT,3,P1)  # Windows and Linux Mystic BBS distros.
			Else
				Delete(TTxT,P1,3)
			Endif
			Insert(UserName,TTxT,P1)
		Endif
	Until P1<1
	Repeat
		P1:=Pos('|&2',TTxT)
		If P1>0 Then
			If PathChar = '/'
				Delete(TTxT,3,P1)
			Else
				Delete(TTxT,P1,3)
			Endif
			Insert(Int2Str(NodeNum),TTxT,P1)
		Endif
	Until P1<1
Pend

Begin
	If ParamCount < 1 Then
		WriteLn('|CRUsage: gy-mton <string_to_pass>|CR|PA')
	Else
		MakeTxt
	Endif
	GetCfg
	GetThisUser
	RunNodes
End
